package com.hfkj.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class BsTradeTakeConfigExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public BsTradeTakeConfigExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNull() {
            addCriterion("company_id is null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNotNull() {
            addCriterion("company_id is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdEqualTo(Long value) {
            addCriterion("company_id =", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotEqualTo(Long value) {
            addCriterion("company_id <>", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThan(Long value) {
            addCriterion("company_id >", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThanOrEqualTo(Long value) {
            addCriterion("company_id >=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThan(Long value) {
            addCriterion("company_id <", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThanOrEqualTo(Long value) {
            addCriterion("company_id <=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIn(List<Long> values) {
            addCriterion("company_id in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotIn(List<Long> values) {
            addCriterion("company_id not in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdBetween(Long value1, Long value2) {
            addCriterion("company_id between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotBetween(Long value1, Long value2) {
            addCriterion("company_id not between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIsNull() {
            addCriterion("company_name is null");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIsNotNull() {
            addCriterion("company_name is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyNameEqualTo(String value) {
            addCriterion("company_name =", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotEqualTo(String value) {
            addCriterion("company_name <>", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameGreaterThan(String value) {
            addCriterion("company_name >", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameGreaterThanOrEqualTo(String value) {
            addCriterion("company_name >=", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLessThan(String value) {
            addCriterion("company_name <", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLessThanOrEqualTo(String value) {
            addCriterion("company_name <=", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLike(String value) {
            addCriterion("company_name like", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotLike(String value) {
            addCriterion("company_name not like", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIn(List<String> values) {
            addCriterion("company_name in", values, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotIn(List<String> values) {
            addCriterion("company_name not in", values, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameBetween(String value1, String value2) {
            addCriterion("company_name between", value1, value2, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotBetween(String value1, String value2) {
            addCriterion("company_name not between", value1, value2, "companyName");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeIsNull() {
            addCriterion("platform_type is null");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeIsNotNull() {
            addCriterion("platform_type is not null");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeEqualTo(Integer value) {
            addCriterion("platform_type =", value, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNotEqualTo(Integer value) {
            addCriterion("platform_type <>", value, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeGreaterThan(Integer value) {
            addCriterion("platform_type >", value, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("platform_type >=", value, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeLessThan(Integer value) {
            addCriterion("platform_type <", value, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeLessThanOrEqualTo(Integer value) {
            addCriterion("platform_type <=", value, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeIn(List<Integer> values) {
            addCriterion("platform_type in", values, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNotIn(List<Integer> values) {
            addCriterion("platform_type not in", values, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeBetween(Integer value1, Integer value2) {
            addCriterion("platform_type between", value1, value2, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("platform_type not between", value1, value2, "platformType");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNameIsNull() {
            addCriterion("platform_type_name is null");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNameIsNotNull() {
            addCriterion("platform_type_name is not null");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNameEqualTo(String value) {
            addCriterion("platform_type_name =", value, "platformTypeName");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNameNotEqualTo(String value) {
            addCriterion("platform_type_name <>", value, "platformTypeName");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNameGreaterThan(String value) {
            addCriterion("platform_type_name >", value, "platformTypeName");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNameGreaterThanOrEqualTo(String value) {
            addCriterion("platform_type_name >=", value, "platformTypeName");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNameLessThan(String value) {
            addCriterion("platform_type_name <", value, "platformTypeName");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNameLessThanOrEqualTo(String value) {
            addCriterion("platform_type_name <=", value, "platformTypeName");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNameLike(String value) {
            addCriterion("platform_type_name like", value, "platformTypeName");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNameNotLike(String value) {
            addCriterion("platform_type_name not like", value, "platformTypeName");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNameIn(List<String> values) {
            addCriterion("platform_type_name in", values, "platformTypeName");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNameNotIn(List<String> values) {
            addCriterion("platform_type_name not in", values, "platformTypeName");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNameBetween(String value1, String value2) {
            addCriterion("platform_type_name between", value1, value2, "platformTypeName");
            return (Criteria) this;
        }

        public Criteria andPlatformTypeNameNotBetween(String value1, String value2) {
            addCriterion("platform_type_name not between", value1, value2, "platformTypeName");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleIsNull() {
            addCriterion("receiver_role is null");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleIsNotNull() {
            addCriterion("receiver_role is not null");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleEqualTo(Integer value) {
            addCriterion("receiver_role =", value, "receiverRole");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleNotEqualTo(Integer value) {
            addCriterion("receiver_role <>", value, "receiverRole");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleGreaterThan(Integer value) {
            addCriterion("receiver_role >", value, "receiverRole");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleGreaterThanOrEqualTo(Integer value) {
            addCriterion("receiver_role >=", value, "receiverRole");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleLessThan(Integer value) {
            addCriterion("receiver_role <", value, "receiverRole");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleLessThanOrEqualTo(Integer value) {
            addCriterion("receiver_role <=", value, "receiverRole");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleIn(List<Integer> values) {
            addCriterion("receiver_role in", values, "receiverRole");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleNotIn(List<Integer> values) {
            addCriterion("receiver_role not in", values, "receiverRole");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleBetween(Integer value1, Integer value2) {
            addCriterion("receiver_role between", value1, value2, "receiverRole");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleNotBetween(Integer value1, Integer value2) {
            addCriterion("receiver_role not between", value1, value2, "receiverRole");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleNameIsNull() {
            addCriterion("receiver_role_name is null");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleNameIsNotNull() {
            addCriterion("receiver_role_name is not null");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleNameEqualTo(String value) {
            addCriterion("receiver_role_name =", value, "receiverRoleName");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleNameNotEqualTo(String value) {
            addCriterion("receiver_role_name <>", value, "receiverRoleName");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleNameGreaterThan(String value) {
            addCriterion("receiver_role_name >", value, "receiverRoleName");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleNameGreaterThanOrEqualTo(String value) {
            addCriterion("receiver_role_name >=", value, "receiverRoleName");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleNameLessThan(String value) {
            addCriterion("receiver_role_name <", value, "receiverRoleName");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleNameLessThanOrEqualTo(String value) {
            addCriterion("receiver_role_name <=", value, "receiverRoleName");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleNameLike(String value) {
            addCriterion("receiver_role_name like", value, "receiverRoleName");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleNameNotLike(String value) {
            addCriterion("receiver_role_name not like", value, "receiverRoleName");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleNameIn(List<String> values) {
            addCriterion("receiver_role_name in", values, "receiverRoleName");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleNameNotIn(List<String> values) {
            addCriterion("receiver_role_name not in", values, "receiverRoleName");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleNameBetween(String value1, String value2) {
            addCriterion("receiver_role_name between", value1, value2, "receiverRoleName");
            return (Criteria) this;
        }

        public Criteria andReceiverRoleNameNotBetween(String value1, String value2) {
            addCriterion("receiver_role_name not between", value1, value2, "receiverRoleName");
            return (Criteria) this;
        }

        public Criteria andReceiverAccountIsNull() {
            addCriterion("receiver_account is null");
            return (Criteria) this;
        }

        public Criteria andReceiverAccountIsNotNull() {
            addCriterion("receiver_account is not null");
            return (Criteria) this;
        }

        public Criteria andReceiverAccountEqualTo(String value) {
            addCriterion("receiver_account =", value, "receiverAccount");
            return (Criteria) this;
        }

        public Criteria andReceiverAccountNotEqualTo(String value) {
            addCriterion("receiver_account <>", value, "receiverAccount");
            return (Criteria) this;
        }

        public Criteria andReceiverAccountGreaterThan(String value) {
            addCriterion("receiver_account >", value, "receiverAccount");
            return (Criteria) this;
        }

        public Criteria andReceiverAccountGreaterThanOrEqualTo(String value) {
            addCriterion("receiver_account >=", value, "receiverAccount");
            return (Criteria) this;
        }

        public Criteria andReceiverAccountLessThan(String value) {
            addCriterion("receiver_account <", value, "receiverAccount");
            return (Criteria) this;
        }

        public Criteria andReceiverAccountLessThanOrEqualTo(String value) {
            addCriterion("receiver_account <=", value, "receiverAccount");
            return (Criteria) this;
        }

        public Criteria andReceiverAccountLike(String value) {
            addCriterion("receiver_account like", value, "receiverAccount");
            return (Criteria) this;
        }

        public Criteria andReceiverAccountNotLike(String value) {
            addCriterion("receiver_account not like", value, "receiverAccount");
            return (Criteria) this;
        }

        public Criteria andReceiverAccountIn(List<String> values) {
            addCriterion("receiver_account in", values, "receiverAccount");
            return (Criteria) this;
        }

        public Criteria andReceiverAccountNotIn(List<String> values) {
            addCriterion("receiver_account not in", values, "receiverAccount");
            return (Criteria) this;
        }

        public Criteria andReceiverAccountBetween(String value1, String value2) {
            addCriterion("receiver_account between", value1, value2, "receiverAccount");
            return (Criteria) this;
        }

        public Criteria andReceiverAccountNotBetween(String value1, String value2) {
            addCriterion("receiver_account not between", value1, value2, "receiverAccount");
            return (Criteria) this;
        }

        public Criteria andReceiverNameIsNull() {
            addCriterion("receiver_name is null");
            return (Criteria) this;
        }

        public Criteria andReceiverNameIsNotNull() {
            addCriterion("receiver_name is not null");
            return (Criteria) this;
        }

        public Criteria andReceiverNameEqualTo(String value) {
            addCriterion("receiver_name =", value, "receiverName");
            return (Criteria) this;
        }

        public Criteria andReceiverNameNotEqualTo(String value) {
            addCriterion("receiver_name <>", value, "receiverName");
            return (Criteria) this;
        }

        public Criteria andReceiverNameGreaterThan(String value) {
            addCriterion("receiver_name >", value, "receiverName");
            return (Criteria) this;
        }

        public Criteria andReceiverNameGreaterThanOrEqualTo(String value) {
            addCriterion("receiver_name >=", value, "receiverName");
            return (Criteria) this;
        }

        public Criteria andReceiverNameLessThan(String value) {
            addCriterion("receiver_name <", value, "receiverName");
            return (Criteria) this;
        }

        public Criteria andReceiverNameLessThanOrEqualTo(String value) {
            addCriterion("receiver_name <=", value, "receiverName");
            return (Criteria) this;
        }

        public Criteria andReceiverNameLike(String value) {
            addCriterion("receiver_name like", value, "receiverName");
            return (Criteria) this;
        }

        public Criteria andReceiverNameNotLike(String value) {
            addCriterion("receiver_name not like", value, "receiverName");
            return (Criteria) this;
        }

        public Criteria andReceiverNameIn(List<String> values) {
            addCriterion("receiver_name in", values, "receiverName");
            return (Criteria) this;
        }

        public Criteria andReceiverNameNotIn(List<String> values) {
            addCriterion("receiver_name not in", values, "receiverName");
            return (Criteria) this;
        }

        public Criteria andReceiverNameBetween(String value1, String value2) {
            addCriterion("receiver_name between", value1, value2, "receiverName");
            return (Criteria) this;
        }

        public Criteria andReceiverNameNotBetween(String value1, String value2) {
            addCriterion("receiver_name not between", value1, value2, "receiverName");
            return (Criteria) this;
        }

        public Criteria andReceiverRatioIsNull() {
            addCriterion("receiver_ratio is null");
            return (Criteria) this;
        }

        public Criteria andReceiverRatioIsNotNull() {
            addCriterion("receiver_ratio is not null");
            return (Criteria) this;
        }

        public Criteria andReceiverRatioEqualTo(BigDecimal value) {
            addCriterion("receiver_ratio =", value, "receiverRatio");
            return (Criteria) this;
        }

        public Criteria andReceiverRatioNotEqualTo(BigDecimal value) {
            addCriterion("receiver_ratio <>", value, "receiverRatio");
            return (Criteria) this;
        }

        public Criteria andReceiverRatioGreaterThan(BigDecimal value) {
            addCriterion("receiver_ratio >", value, "receiverRatio");
            return (Criteria) this;
        }

        public Criteria andReceiverRatioGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("receiver_ratio >=", value, "receiverRatio");
            return (Criteria) this;
        }

        public Criteria andReceiverRatioLessThan(BigDecimal value) {
            addCriterion("receiver_ratio <", value, "receiverRatio");
            return (Criteria) this;
        }

        public Criteria andReceiverRatioLessThanOrEqualTo(BigDecimal value) {
            addCriterion("receiver_ratio <=", value, "receiverRatio");
            return (Criteria) this;
        }

        public Criteria andReceiverRatioIn(List<BigDecimal> values) {
            addCriterion("receiver_ratio in", values, "receiverRatio");
            return (Criteria) this;
        }

        public Criteria andReceiverRatioNotIn(List<BigDecimal> values) {
            addCriterion("receiver_ratio not in", values, "receiverRatio");
            return (Criteria) this;
        }

        public Criteria andReceiverRatioBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("receiver_ratio between", value1, value2, "receiverRatio");
            return (Criteria) this;
        }

        public Criteria andReceiverRatioNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("receiver_ratio not between", value1, value2, "receiverRatio");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectIdIsNull() {
            addCriterion("receiver_object_id is null");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectIdIsNotNull() {
            addCriterion("receiver_object_id is not null");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectIdEqualTo(Long value) {
            addCriterion("receiver_object_id =", value, "receiverObjectId");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectIdNotEqualTo(Long value) {
            addCriterion("receiver_object_id <>", value, "receiverObjectId");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectIdGreaterThan(Long value) {
            addCriterion("receiver_object_id >", value, "receiverObjectId");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectIdGreaterThanOrEqualTo(Long value) {
            addCriterion("receiver_object_id >=", value, "receiverObjectId");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectIdLessThan(Long value) {
            addCriterion("receiver_object_id <", value, "receiverObjectId");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectIdLessThanOrEqualTo(Long value) {
            addCriterion("receiver_object_id <=", value, "receiverObjectId");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectIdIn(List<Long> values) {
            addCriterion("receiver_object_id in", values, "receiverObjectId");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectIdNotIn(List<Long> values) {
            addCriterion("receiver_object_id not in", values, "receiverObjectId");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectIdBetween(Long value1, Long value2) {
            addCriterion("receiver_object_id between", value1, value2, "receiverObjectId");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectIdNotBetween(Long value1, Long value2) {
            addCriterion("receiver_object_id not between", value1, value2, "receiverObjectId");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectNameIsNull() {
            addCriterion("receiver_object_name is null");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectNameIsNotNull() {
            addCriterion("receiver_object_name is not null");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectNameEqualTo(String value) {
            addCriterion("receiver_object_name =", value, "receiverObjectName");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectNameNotEqualTo(String value) {
            addCriterion("receiver_object_name <>", value, "receiverObjectName");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectNameGreaterThan(String value) {
            addCriterion("receiver_object_name >", value, "receiverObjectName");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectNameGreaterThanOrEqualTo(String value) {
            addCriterion("receiver_object_name >=", value, "receiverObjectName");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectNameLessThan(String value) {
            addCriterion("receiver_object_name <", value, "receiverObjectName");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectNameLessThanOrEqualTo(String value) {
            addCriterion("receiver_object_name <=", value, "receiverObjectName");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectNameLike(String value) {
            addCriterion("receiver_object_name like", value, "receiverObjectName");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectNameNotLike(String value) {
            addCriterion("receiver_object_name not like", value, "receiverObjectName");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectNameIn(List<String> values) {
            addCriterion("receiver_object_name in", values, "receiverObjectName");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectNameNotIn(List<String> values) {
            addCriterion("receiver_object_name not in", values, "receiverObjectName");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectNameBetween(String value1, String value2) {
            addCriterion("receiver_object_name between", value1, value2, "receiverObjectName");
            return (Criteria) this;
        }

        public Criteria andReceiverObjectNameNotBetween(String value1, String value2) {
            addCriterion("receiver_object_name not between", value1, value2, "receiverObjectName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleIsNull() {
            addCriterion("sub_receiver_role is null");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleIsNotNull() {
            addCriterion("sub_receiver_role is not null");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleEqualTo(Integer value) {
            addCriterion("sub_receiver_role =", value, "subReceiverRole");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleNotEqualTo(Integer value) {
            addCriterion("sub_receiver_role <>", value, "subReceiverRole");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleGreaterThan(Integer value) {
            addCriterion("sub_receiver_role >", value, "subReceiverRole");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleGreaterThanOrEqualTo(Integer value) {
            addCriterion("sub_receiver_role >=", value, "subReceiverRole");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleLessThan(Integer value) {
            addCriterion("sub_receiver_role <", value, "subReceiverRole");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleLessThanOrEqualTo(Integer value) {
            addCriterion("sub_receiver_role <=", value, "subReceiverRole");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleIn(List<Integer> values) {
            addCriterion("sub_receiver_role in", values, "subReceiverRole");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleNotIn(List<Integer> values) {
            addCriterion("sub_receiver_role not in", values, "subReceiverRole");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleBetween(Integer value1, Integer value2) {
            addCriterion("sub_receiver_role between", value1, value2, "subReceiverRole");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleNotBetween(Integer value1, Integer value2) {
            addCriterion("sub_receiver_role not between", value1, value2, "subReceiverRole");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleNameIsNull() {
            addCriterion("sub_receiver_role_name is null");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleNameIsNotNull() {
            addCriterion("sub_receiver_role_name is not null");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleNameEqualTo(String value) {
            addCriterion("sub_receiver_role_name =", value, "subReceiverRoleName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleNameNotEqualTo(String value) {
            addCriterion("sub_receiver_role_name <>", value, "subReceiverRoleName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleNameGreaterThan(String value) {
            addCriterion("sub_receiver_role_name >", value, "subReceiverRoleName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleNameGreaterThanOrEqualTo(String value) {
            addCriterion("sub_receiver_role_name >=", value, "subReceiverRoleName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleNameLessThan(String value) {
            addCriterion("sub_receiver_role_name <", value, "subReceiverRoleName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleNameLessThanOrEqualTo(String value) {
            addCriterion("sub_receiver_role_name <=", value, "subReceiverRoleName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleNameLike(String value) {
            addCriterion("sub_receiver_role_name like", value, "subReceiverRoleName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleNameNotLike(String value) {
            addCriterion("sub_receiver_role_name not like", value, "subReceiverRoleName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleNameIn(List<String> values) {
            addCriterion("sub_receiver_role_name in", values, "subReceiverRoleName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleNameNotIn(List<String> values) {
            addCriterion("sub_receiver_role_name not in", values, "subReceiverRoleName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleNameBetween(String value1, String value2) {
            addCriterion("sub_receiver_role_name between", value1, value2, "subReceiverRoleName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRoleNameNotBetween(String value1, String value2) {
            addCriterion("sub_receiver_role_name not between", value1, value2, "subReceiverRoleName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverAccountIsNull() {
            addCriterion("sub_receiver_account is null");
            return (Criteria) this;
        }

        public Criteria andSubReceiverAccountIsNotNull() {
            addCriterion("sub_receiver_account is not null");
            return (Criteria) this;
        }

        public Criteria andSubReceiverAccountEqualTo(String value) {
            addCriterion("sub_receiver_account =", value, "subReceiverAccount");
            return (Criteria) this;
        }

        public Criteria andSubReceiverAccountNotEqualTo(String value) {
            addCriterion("sub_receiver_account <>", value, "subReceiverAccount");
            return (Criteria) this;
        }

        public Criteria andSubReceiverAccountGreaterThan(String value) {
            addCriterion("sub_receiver_account >", value, "subReceiverAccount");
            return (Criteria) this;
        }

        public Criteria andSubReceiverAccountGreaterThanOrEqualTo(String value) {
            addCriterion("sub_receiver_account >=", value, "subReceiverAccount");
            return (Criteria) this;
        }

        public Criteria andSubReceiverAccountLessThan(String value) {
            addCriterion("sub_receiver_account <", value, "subReceiverAccount");
            return (Criteria) this;
        }

        public Criteria andSubReceiverAccountLessThanOrEqualTo(String value) {
            addCriterion("sub_receiver_account <=", value, "subReceiverAccount");
            return (Criteria) this;
        }

        public Criteria andSubReceiverAccountLike(String value) {
            addCriterion("sub_receiver_account like", value, "subReceiverAccount");
            return (Criteria) this;
        }

        public Criteria andSubReceiverAccountNotLike(String value) {
            addCriterion("sub_receiver_account not like", value, "subReceiverAccount");
            return (Criteria) this;
        }

        public Criteria andSubReceiverAccountIn(List<String> values) {
            addCriterion("sub_receiver_account in", values, "subReceiverAccount");
            return (Criteria) this;
        }

        public Criteria andSubReceiverAccountNotIn(List<String> values) {
            addCriterion("sub_receiver_account not in", values, "subReceiverAccount");
            return (Criteria) this;
        }

        public Criteria andSubReceiverAccountBetween(String value1, String value2) {
            addCriterion("sub_receiver_account between", value1, value2, "subReceiverAccount");
            return (Criteria) this;
        }

        public Criteria andSubReceiverAccountNotBetween(String value1, String value2) {
            addCriterion("sub_receiver_account not between", value1, value2, "subReceiverAccount");
            return (Criteria) this;
        }

        public Criteria andSubReceiverNameIsNull() {
            addCriterion("sub_receiver_name is null");
            return (Criteria) this;
        }

        public Criteria andSubReceiverNameIsNotNull() {
            addCriterion("sub_receiver_name is not null");
            return (Criteria) this;
        }

        public Criteria andSubReceiverNameEqualTo(String value) {
            addCriterion("sub_receiver_name =", value, "subReceiverName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverNameNotEqualTo(String value) {
            addCriterion("sub_receiver_name <>", value, "subReceiverName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverNameGreaterThan(String value) {
            addCriterion("sub_receiver_name >", value, "subReceiverName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverNameGreaterThanOrEqualTo(String value) {
            addCriterion("sub_receiver_name >=", value, "subReceiverName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverNameLessThan(String value) {
            addCriterion("sub_receiver_name <", value, "subReceiverName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverNameLessThanOrEqualTo(String value) {
            addCriterion("sub_receiver_name <=", value, "subReceiverName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverNameLike(String value) {
            addCriterion("sub_receiver_name like", value, "subReceiverName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverNameNotLike(String value) {
            addCriterion("sub_receiver_name not like", value, "subReceiverName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverNameIn(List<String> values) {
            addCriterion("sub_receiver_name in", values, "subReceiverName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverNameNotIn(List<String> values) {
            addCriterion("sub_receiver_name not in", values, "subReceiverName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverNameBetween(String value1, String value2) {
            addCriterion("sub_receiver_name between", value1, value2, "subReceiverName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverNameNotBetween(String value1, String value2) {
            addCriterion("sub_receiver_name not between", value1, value2, "subReceiverName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRatioIsNull() {
            addCriterion("sub_receiver_ratio is null");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRatioIsNotNull() {
            addCriterion("sub_receiver_ratio is not null");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRatioEqualTo(BigDecimal value) {
            addCriterion("sub_receiver_ratio =", value, "subReceiverRatio");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRatioNotEqualTo(BigDecimal value) {
            addCriterion("sub_receiver_ratio <>", value, "subReceiverRatio");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRatioGreaterThan(BigDecimal value) {
            addCriterion("sub_receiver_ratio >", value, "subReceiverRatio");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRatioGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sub_receiver_ratio >=", value, "subReceiverRatio");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRatioLessThan(BigDecimal value) {
            addCriterion("sub_receiver_ratio <", value, "subReceiverRatio");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRatioLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sub_receiver_ratio <=", value, "subReceiverRatio");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRatioIn(List<BigDecimal> values) {
            addCriterion("sub_receiver_ratio in", values, "subReceiverRatio");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRatioNotIn(List<BigDecimal> values) {
            addCriterion("sub_receiver_ratio not in", values, "subReceiverRatio");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRatioBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sub_receiver_ratio between", value1, value2, "subReceiverRatio");
            return (Criteria) this;
        }

        public Criteria andSubReceiverRatioNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sub_receiver_ratio not between", value1, value2, "subReceiverRatio");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectIdIsNull() {
            addCriterion("sub_receiver_object_id is null");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectIdIsNotNull() {
            addCriterion("sub_receiver_object_id is not null");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectIdEqualTo(Long value) {
            addCriterion("sub_receiver_object_id =", value, "subReceiverObjectId");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectIdNotEqualTo(Long value) {
            addCriterion("sub_receiver_object_id <>", value, "subReceiverObjectId");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectIdGreaterThan(Long value) {
            addCriterion("sub_receiver_object_id >", value, "subReceiverObjectId");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectIdGreaterThanOrEqualTo(Long value) {
            addCriterion("sub_receiver_object_id >=", value, "subReceiverObjectId");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectIdLessThan(Long value) {
            addCriterion("sub_receiver_object_id <", value, "subReceiverObjectId");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectIdLessThanOrEqualTo(Long value) {
            addCriterion("sub_receiver_object_id <=", value, "subReceiverObjectId");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectIdIn(List<Long> values) {
            addCriterion("sub_receiver_object_id in", values, "subReceiverObjectId");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectIdNotIn(List<Long> values) {
            addCriterion("sub_receiver_object_id not in", values, "subReceiverObjectId");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectIdBetween(Long value1, Long value2) {
            addCriterion("sub_receiver_object_id between", value1, value2, "subReceiverObjectId");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectIdNotBetween(Long value1, Long value2) {
            addCriterion("sub_receiver_object_id not between", value1, value2, "subReceiverObjectId");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectNameIsNull() {
            addCriterion("sub_receiver_object_name is null");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectNameIsNotNull() {
            addCriterion("sub_receiver_object_name is not null");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectNameEqualTo(String value) {
            addCriterion("sub_receiver_object_name =", value, "subReceiverObjectName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectNameNotEqualTo(String value) {
            addCriterion("sub_receiver_object_name <>", value, "subReceiverObjectName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectNameGreaterThan(String value) {
            addCriterion("sub_receiver_object_name >", value, "subReceiverObjectName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectNameGreaterThanOrEqualTo(String value) {
            addCriterion("sub_receiver_object_name >=", value, "subReceiverObjectName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectNameLessThan(String value) {
            addCriterion("sub_receiver_object_name <", value, "subReceiverObjectName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectNameLessThanOrEqualTo(String value) {
            addCriterion("sub_receiver_object_name <=", value, "subReceiverObjectName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectNameLike(String value) {
            addCriterion("sub_receiver_object_name like", value, "subReceiverObjectName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectNameNotLike(String value) {
            addCriterion("sub_receiver_object_name not like", value, "subReceiverObjectName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectNameIn(List<String> values) {
            addCriterion("sub_receiver_object_name in", values, "subReceiverObjectName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectNameNotIn(List<String> values) {
            addCriterion("sub_receiver_object_name not in", values, "subReceiverObjectName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectNameBetween(String value1, String value2) {
            addCriterion("sub_receiver_object_name between", value1, value2, "subReceiverObjectName");
            return (Criteria) this;
        }

        public Criteria andSubReceiverObjectNameNotBetween(String value1, String value2) {
            addCriterion("sub_receiver_object_name not between", value1, value2, "subReceiverObjectName");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("`status` is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("`status` is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("`status` =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("`status` <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("`status` >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("`status` >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("`status` <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("`status` <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("`status` in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("`status` not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("`status` between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("`status` not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andOpUserIdIsNull() {
            addCriterion("op_user_id is null");
            return (Criteria) this;
        }

        public Criteria andOpUserIdIsNotNull() {
            addCriterion("op_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andOpUserIdEqualTo(Long value) {
            addCriterion("op_user_id =", value, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdNotEqualTo(Long value) {
            addCriterion("op_user_id <>", value, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdGreaterThan(Long value) {
            addCriterion("op_user_id >", value, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("op_user_id >=", value, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdLessThan(Long value) {
            addCriterion("op_user_id <", value, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdLessThanOrEqualTo(Long value) {
            addCriterion("op_user_id <=", value, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdIn(List<Long> values) {
            addCriterion("op_user_id in", values, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdNotIn(List<Long> values) {
            addCriterion("op_user_id not in", values, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdBetween(Long value1, Long value2) {
            addCriterion("op_user_id between", value1, value2, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdNotBetween(Long value1, Long value2) {
            addCriterion("op_user_id not between", value1, value2, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserNameIsNull() {
            addCriterion("op_user_name is null");
            return (Criteria) this;
        }

        public Criteria andOpUserNameIsNotNull() {
            addCriterion("op_user_name is not null");
            return (Criteria) this;
        }

        public Criteria andOpUserNameEqualTo(String value) {
            addCriterion("op_user_name =", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameNotEqualTo(String value) {
            addCriterion("op_user_name <>", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameGreaterThan(String value) {
            addCriterion("op_user_name >", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameGreaterThanOrEqualTo(String value) {
            addCriterion("op_user_name >=", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameLessThan(String value) {
            addCriterion("op_user_name <", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameLessThanOrEqualTo(String value) {
            addCriterion("op_user_name <=", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameLike(String value) {
            addCriterion("op_user_name like", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameNotLike(String value) {
            addCriterion("op_user_name not like", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameIn(List<String> values) {
            addCriterion("op_user_name in", values, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameNotIn(List<String> values) {
            addCriterion("op_user_name not in", values, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameBetween(String value1, String value2) {
            addCriterion("op_user_name between", value1, value2, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameNotBetween(String value1, String value2) {
            addCriterion("op_user_name not between", value1, value2, "opUserName");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}